/*
  generic outputdevice for yaf
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */





#include <devices/outputDevice.h>

// dynamic setting of acc-functions? would be nice
// (nice "use MMX" button in gui?)
static Filter* filter=new Filter();


OutputDevice::OutputDevice(){
  deliverMode=_DELIVER_MODE_WITH_NOTIFY;
  lData=false;
  ::pipe(fd);
  sn=new QSocketNotifier( fd[0], QSocketNotifier::Read, NULL );
  QObject::connect(sn,SIGNAL(activated(int)),this,SLOT(dataReceivedNotify()));
  pthread_mutex_init(&dataMut,NULL);
}


OutputDevice::~OutputDevice() {
}


char* OutputDevice::getNodeName() {
  return "OutputDevice";
}



int OutputDevice::openDevice() {
  return true;
}



int OutputDevice::closeDevice() {
  return true;
}


  
void OutputDevice::jump(float sec) {
}




void OutputDevice::dataReceivedNotify() {
  char dummy;
  ::read(fd[0],&dummy,1);
  lData=false;
  if (deliverMode != _DELIVER_MODE_NO_NOTIFY) {
    emit (dataNotify()); 
  }
}


void OutputDevice::dataSendNotify() {
  pthread_mutex_lock(&dataMut);
  if (lData==false) {
    lData=true;
    write(fd[1],"1",1);
  }
  pthread_mutex_unlock(&dataMut);
}




void OutputDevice::clearData() {
  writeOutLock();
  pthread_mutex_lock(&dataMut);
  lData=false;
  pthread_mutex_unlock(&dataMut);
  writeOutUnlock();
}


int OutputDevice::getData() {
  return lData;
}
  

void OutputDevice::setDeliverMode(int deliverMode) {
  writeOutLock();
  cout << "setDeliverMode to:"<<deliverMode<<endl;
  this->deliverMode=deliverMode;
  writeOutUnlock();
}


int OutputDevice::getDeliverMode() {
  return deliverMode;
}


Accelerator* OutputDevice::getAccelerator() {
  return filter->getAccelerator();
}


