/*
  very simple audiodevice for linux (only for debugging)
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */


#include <yafcore/audioLinux.h>



AudioLinux::AudioLinux() {
  fd=-2;
}

AudioLinux::~AudioLinux() {
  if (isOpen()) {
    close();
  }
}
 

int AudioLinux::isOpen() {
  return (fd > 0);
}

int AudioLinux::open() {
  if (fd > 0) close();
  fd=::open("/dev/dsp",O_WRONLY ,0);
  if (fd <0) {
    cout << "error opening device !"<<endl;
  }
  return fd;
}  
 
int AudioLinux::close() {
  int back;
  if (fd < 0) {
    cout << "device already closed!"<<endl;
    return 0;
  }
  back=::close(fd);
  fd=-2;
  return back;
}


    


void AudioLinux::init(int channel,int bits, int freq) {
  int stereo=channel-1;

  if (isOpen()) {
    cout << "init audiDevice!"<<endl;
    ioctl(fd,SNDCTL_DSP_RESET,NULL);
    ioctl(fd,SNDCTL_DSP_STEREO,&stereo);
    ioctl(fd,SNDCTL_DSP_SAMPLESIZE,&bits);
    ioctl(fd,SNDCTL_DSP_SPEED,&freq);
  } else {
    cout << "cannot init AudioDevice->not open!"<<endl;
  }
}


void AudioLinux::write(char* buf,int len) {
  ::write(fd,buf,len);
}


